<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="utf-8" />
  <meta name="viewport" content="width=device-width, initial-scale=1" />
  <title>Courses CRUD</title>
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css">
  <!-- Data Table-->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
  <link href="https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.13/css/select2.min.css" rel="stylesheet" />
  <script src="https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.13/js/select2.min.js"></script>
  <style>
    .container {
      width: 500px;
      margin-top: 50px;
      gap: 20px;
    }

    select#province {
      height: 30px;
    }
  </style>
</head>

<body>
  <div class="container-fluid row">
    <div class="container">
      <h2>Tỉnh thành</h2>
      <div class="form-group row">
        <label for="province-name" class="col-sm-4">Tên: </label>
        <input placeholder="Tỉnh thành" class="col-sm-8 scrollable-menu" id="province-name" />
      </div>
      <div class="form-group row">
        <label for="province-code" class="col-sm-4">Mã: </label>
        <input placeholder="Mã" class="col-sm-8 scrollable-menu" id="province-code" />
      </div>
      <div class="container row ">
        <button class="btn btn-primary province-btn">Add</button>
        <button class="btn btn-outline-dark">Cancel</button>
      </div>
    </div>
    <div class="container">
      <h2>Quận huyện</h2>
      <div class="form-group row">
        <label for="district-name" class="col-sm-4">Tên: </label>
        <input placeholder="Tên" class="col-sm-8 scrollable-menu" id="district-name" />
      </div>
      <div class="form-group row">
        <label for="district-name" class="col-sm-4">Tên TP:</label>
        <select class="col-sm-8" id="district-select">
          <option selected>Tên</option>
        </select>
      </div>
      <div class="form-group row">
        <label for="district-prefix" class="col-sm-4">Quận-Huyện:</label>
        <select class="col-sm-8" id="district-prefix">
          <option selected>Quận-Huyện</option>
          <option>Quận</option>
          <option>Huyện</option>
        </select>
      </div>
      <div class="container row ">
        <button class="btn btn-primary district-btn">Add</button>
        <button class="btn btn-outline-dark">Cancel</button>
      </div>
    </div>
    <div class="container">
      <h2>Phường xã</h2>
      <div class="form-group row">
        <label for="ward-name" class="col-sm-4">Tên: </label>
        <input placeholder="Tên" class="col-sm-8 scrollable-menu" id="ward-name" />
      </div>

      <div class="form-group row">
        <label for="ward-prefix" class="col-sm-4">Phường xã:</label>
        <select class="col-sm-8" id="ward-prefix">
          <option selected>Phường,xã</option>
          <option selected>Xã</option>
          <option selected>Phường</option>
          <option selected>Thị Trấn</option>
        </select>
      </div>
      <div class="form-group row">
        <label for="ward-province" class="col-sm-4">Tỉnh thành:</label>
        <select class="col-sm-8" id="ward-province">
          <option selected>Tỉnh thành</option>
        </select>
      </div>
      <div class="form-group row">
        <label for="ward-district" class="col-sm-4">Quận huyện:</label>
        <select class="col-sm-8" id="ward-district">
          <option selected>Quận huyện</option>
        </select>
      </div>
      <div class="container row">
        <button class="btn btn-primary ward-btn">Add</button>
        <button class="btn btn-outline-dark">Cancel</button>
      </div>
    </div>
  </div>

</body>

<script>
  const gPROVINCE_LIST = "http://localhost:8080/api/province-list";
  const gPROVINCE_URL = "http://localhost:8080/api/province";
  const gDISTRICT_URL = "http://localhost:8080/api/district";
  const gWARD_URL = "http://localhost:8080/api/ward";

  class Main {
    constructor() {
      $(document).ready(() => {
        this.pageRender = new RenderPage()
        this.pageRender.renderPage()

      })
    }

  }
  new Main()
  /*** REGION 2 - vùng để render ra bảng*/
  class RenderPage {

    constructor() {
      this.vApi = new CallApi()
    }

    _onEventListener() {
      $("#ward-province").on("change",(e)=> {
      const vProvinceId = parseInt(e.target.value)
      this.vApi.onGetDistrictByProvince(vProvinceId,(paramDistrictList)=>{
        const selectElement = $("#ward-district");
        selectElement.empty();
        selectElement.append('<option selected>Quận, huyện</option>');
        paramDistrictList.forEach((district) => {
          selectElement.append(`<option value="${district.id}">${district.name}</option>`);
        });
      })
      })
    }

    _getProvinceList() {
      const pageSize = 10;
      let currentPage = 1;
      var self = this;

      this.vApi.onGetProvinceList(currentPage, pageSize, (paramProvinceList) => {
        const selectElement = $("#district-select");
        const selectElement2 = $("#ward-province");
        selectElement.empty();
        selectElement2.empty()
        selectElement.append('<option selected>Tên</option>');
        selectElement2.append('<option selected>Tỉnh thành</option>');
        paramProvinceList.forEach((province) => {
          selectElement.append(`<option value="${province.id}">${province.name}</option>`);
          selectElement2.append(`<option value="${province.id}">${province.name}</option>`);
        });
      });
    } 

    _createProvince() {
      $('.province-btn').on('click', () => {
        const name = $('#province-name').val();
        const code = $('#province-code').val();

        if (name.trim() === '' || code.trim() === '') {
          return;
        }
        const province = {
          name: name,
          code: code,
        }
        this.vApi.onCreateProvince(province, (paramProvince) => {
          console.log(province);
        })
      });
    }

    _createDistrict() {
      $('.district-btn').on('click', () => {
        const name = $('#district-name').val();
        const prefix = $('#district-prefix').val();
        const provinceId = parseInt($('#district-select').val())
        if (name.trim() === '' || prefix.trim() === '') {
          return;
        }
        this.vApi.onGetProvinceById(provinceId, (province) => {
          const district = {
            name: name,
            prefix: prefix,
            province: province
          }
          this.vApi.onCreateDistrict(district, (paramDistrict) => {
            console.log(district);
          })
        })


      });
    }

    _createWard() {
      $('.ward-btn').on('click', () => {
        const name = $('#ward-name').val();
        const prefix = $('#ward-prefix').val();
        const districtId = parseInt($('#ward-district').val())
        if (name.trim() === '' || prefix.trim() === '') {
          return;
        }
        this.vApi.onGetDistrictById(districtId, (paramDistrict) => {
          const ward = {
            name: name,
            prefix: prefix,
            district: paramDistrict
          }
          this.vApi.onCreateWard(ward, (paramWard) => {
            console.log(paramWard);
          })
        })


      });
    }


    _getDistrictListByProvince(provinceId) {
      var self = this;
      var selectElement = $('#ward-district');
      selectElement.empty();
      var defaultOption = $('<option></option>');
      defaultOption.val('');
      defaultOption.text('Quận, huyện');
      selectElement.append(defaultOption);

      this.vApi.onGetDistrictByProvince(provinceId, (paramDistrictList) => {
        paramDistrictList.forEach(function (district) {
          var optionElement = $('<option></option>');
          optionElement.val(district.id);
          optionElement.text(district.name);

          selectElement.append(optionElement);
        });
      })

      selectElement.on('change', function () {
        var selectedDistrictId = $(this).val();
        self._getWardByDistrict(selectedDistrictId);
      });
    }

    _getWardByDistrict(districtId) {
      var self = this;
      var selectElement = $('#ward');
      selectElement.empty();
      var defaultOption = $('<option></option>');
      defaultOption.val('');
      defaultOption.text('Phường, xã');
      selectElement.append(defaultOption);

      this.vApi.onGetWardByDistrict(districtId, (paramWardList) => {
        paramWardList.forEach(function (ward) {
          var optionElement = $('<option></option>');
          optionElement.val(ward.id);
          optionElement.text(ward.name);

          selectElement.append(optionElement);
        });
      });
    }
    // Hàm sẽ được gọi ở class Main 
    renderPage() {
      this._getProvinceList()
      this._createProvince()
      this._createDistrict()
      this._onEventListener()
      this._createWard()
    }
  }

  /*** REGION 3 - vùng để gọi lên cơ sở dữ liệu lấy đa ta về*/
  class CallApi {
    constructor() {

    }
    onGetProvinceList(page, size, paramCallbackFn) {

      $.ajax({
        url: `${gPROVINCE_LIST}?page =${page}&size=${size}`,
        method: "GET",
        success: function (data) {
          paramCallbackFn(data)
        },
        error: function (jqXHR, textStatus, errorThrown) {

        }
      });
    }

    onGetProvinceById(paramId, paramCallbackFn) {

      $.ajax({
        url: `${gPROVINCE_URL}/${paramId}`,
        method: "GET",
        success: function (data) {
          paramCallbackFn(data)
        },
        error: function (jqXHR, textStatus, errorThrown) {

        }
      });
    }
    onCreateProvince(province, paramCallbackFn) {
      $.ajax({
        url: gPROVINCE_URL,
        method: "POST",
        data: JSON.stringify(province),
        contentType: "application/json",
        success: function (data) {
          paramCallbackFn(data);
        },
        error: function (jqXHR, textStatus, errorThrown) {
          // Handle error
        }
      });
    }
    onCreateDistrict(district, paramCallbackFn) {
      $.ajax({
        url: gDISTRICT_URL,
        method: "POST",
        data: JSON.stringify(district),
        contentType: "application/json",
        success: function (data) {
          paramCallbackFn(data);
        },
        error: function (jqXHR, textStatus, errorThrown) {
          // Handle error
        }
      });
    }
    onCreateWard(ward, paramCallbackFn) {
      $.ajax({
        url: gWARD_URL,
        method: "POST",
        data: JSON.stringify(ward),
        contentType: "application/json",
        success: function (data) {
          paramCallbackFn(data);
        },
        error: function (jqXHR, textStatus, errorThrown) {
          // Handle error
        }
      });
    }

    onGetDistrictByProvince(provinceId, paramCallbackFn) {

      $.ajax({
        url: `${gDISTRICT_URL}/${provinceId}`,
        method: "GET",
        success: function (data) {
          paramCallbackFn(data)
        },
        error: function (jqXHR, textStatus, errorThrown) {

        }
      });
    }

    
    onGetDistrictById(districtId, paramCallbackFn) {
      $.ajax({
        url: `${gDISTRICT_URL}?id=${districtId}`,
        method: "GET",
        success: function (data) {
          paramCallbackFn(data)
        },
        error: function (jqXHR, textStatus, errorThrown) {

        }
      });
    }


    onGetWardByDistrict(wardId, paramCallbackFn) {

      $.ajax({
        url: `${gWARD_LIST}/${wardId}`,
        method: "GET",
        success: function (data) {
          paramCallbackFn(data)
        },
        error: function (jqXHR, textStatus, errorThrown) {

        }
      });
    }

  }

</script>

</html>